/*
 * MODULE: pstr.c
*/

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "pstr.h"

const char *pstr_create(const char *s1, ...)
{
	va_list ap;
	const char *cp;
	size_t len;
	char *res;

	len = 1;
	va_start(ap, s1);
	for (cp = s1; cp != (char *)0; cp = va_arg(ap, const char *))
		len += strlen(cp);
	va_end(ap);
	res = (char *)malloc(len);
	if (res == (char *)0) abort();
	res[0] = '\0';
	va_start(ap, s1);
	for (cp = s1; cp != (char *)0; cp = va_arg(ap, const char *))
		(void) strcat(res, cp);
	va_end(ap);

	return res;
}

void pstr_delete(const char *str)
{
	if (str != (char *)0)
		/*CASTAWAYCONST*/
		free((void *)str);
}

const char *pstr_temp(const char * str)
{
	static const char *last;
	pstr_delete(last);
	return (last = str);
}

void pstr_assign(const char **dest, const char *src)
{
	pstr_delete(*dest);
	(*dest) = pstr_create(src, (char *)0);
}
