/*
 * demo.c - Demonstration der Funktionsweise der neuen Funktion
 *          XtAppMainLoop(), die die bisherige Xt-Variante vom MIT
 *          ersetzt.
 * Letzte Modifikation: 17.02.1994
 * Harald Albrecht ( albrecht@igpm.rwth-aachen.de )
 */

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <X11/keysym.h>
#include <stdio.h>

void DummyCallback(Widget w, XtPointer clientdata, XtPointer calldata)
{
    KeySym KSym;
    fprintf(stderr, "%s\n", XtName(w));
    XtVaGetValues(w, XmNmnemonic, &KSym, NULL);
    if ( KSym == XK_B ) exit(0);
} /* DummyCallback */

int main(Cardinal argc, char **argv)
{
    XtAppContext AppCtx;
    Widget       TopLevel, Main, Menu, Form, Text, PullDownMenu;
    Widget       Cascade, Butt1, Butt2, Butt3, Butt4, Butt5;
    Widget       Frame, Label, RowCol;
    XmString     str1, str2, str3;
    Arg          args[10];
    
    TopLevel = XtVaAppInitialize(&AppCtx, "Demo", NULL, 0, 
                                 &argc, argv, NULL, NULL);
    Main = XmCreateMainWindow(TopLevel, "main", NULL, 0);
    XtManageChild(Main);
    Menu = XmCreateMenuBar(Main, "menu", NULL, 0);
    XtManageChild(Menu);
    XtSetArg(args[0], XmNmnemonic, XK_D);
    Cascade = XmCreateCascadeButton(Menu, "Datei", args, 1);
    XtManageChild(Cascade);
    str1 = XmStringCreateSimple("Beenden");
    str2 = XmStringCreateSimple("Ignorieren");
    str3 = XmStringCreateSimple("\334bergehen");
    PullDownMenu = XmVaCreateSimplePulldownMenu(Menu, "datei", 0, 
        (XtCallbackProc) DummyCallback, 
	XmVaPUSHBUTTON, str2, XK_I, NULL, NULL, 
	XmVaPUSHBUTTON, str3, XK_g, NULL, NULL, 
/* einige Motif-Versionen haben eventuell mit der naechsten Zeile
   Probleme, in diesem Fall XmVaSEPARATOR einfach auskommentieren */
	XmVaSEPARATOR, 
	XmVaPUSHBUTTON, str1, XK_B, NULL, NULL, 
	NULL);
    XmStringFree(str1); XmStringFree(str2); XmStringFree(str3);
    Form = XtVaCreateManagedWidget("form", xmFormWidgetClass, Main, NULL);
    Butt1 = XtVaCreateManagedWidget(
	"Mach Schlu\337!",  xmPushButtonWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      20, 
	XmNtopAttachment,   XmATTACH_FORM, 
	XmNtopOffset,       8, 
	XmNmnemonic,	    XK_M, 
	NULL);
    Butt2 = XtVaCreateManagedWidget(
	"Klick mich an...", xmPushButtonWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_WIDGET, 
	XmNleftWidget,      Butt1, 
	XmNleftOffset,      5, 
	XmNtopAttachment,   XmATTACH_FORM, 
	XmNtopOffset,       8, 
	XmNrightAttachment, XmATTACH_FORM, 
	XmNrightOffset,     5, 
	XmNmnemonic,	    XK_K, 
	NULL);
/* Der folgende Schalter wird erst im zweiten Teil des Artikels benoetigt */
    Label = XtVaCreateManagedWidget(
        "Schalter", xmLabelWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      24,
	XmNtopAttachment,   XmATTACH_WIDGET, 
	XmNtopWidget,       Butt1, 
	XmNtopOffset,       8, 
	XmNmnemonic,        XK_S, 
	NULL);
    Frame = XtVaCreateManagedWidget(
        "Rahmen", xmFrameWidgetClass, Form, 
	XmNleftAttachment,  XmATTACH_FORM, 
	XmNleftOffset,      20, 
	XmNtopAttachment,   XmATTACH_WIDGET, 
	XmNtopWidget,       Label, 
	XmNrightAttachment, XmATTACH_FORM, 
	XmNrightOffset,     20,  
	NULL);
    RowCol = XtVaCreateManagedWidget(
	"RowCol", xmRowColumnWidgetClass, Frame, 
        NULL);
    Butt3 = XtVaCreateManagedWidget(
	"Nicht umschaltbar", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_N, 
	XmNsensitive, False, 
	NULL);
    Butt4 = XtVaCreateManagedWidget(
	"Umschaltbar", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_U, 
	NULL);
    Butt5 = XtVaCreateManagedWidget(
	"Ich auch!", xmToggleButtonWidgetClass, RowCol,
	XmNmnemonic,        XK_I, 
	NULL);
    Text = XtVaCreateManagedWidget(
	"Beispiel f\374r die neue Funktion XtAppMainLoop()", 
	xmLabelWidgetClass, Form, 
	XmNleftAttachment,   XmATTACH_FORM, 
	XmNleftOffset,	     20, 
	XmNrightAttachment,  XmATTACH_FORM, 
	XmNrightOffset,	     20, 
	XmNtopAttachment,    XmATTACH_WIDGET, 
	XmNtopWidget,        Frame, 
	XmNtopOffset,        20, 
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNbottomOffset,     20, 
	NULL);
    XmMainWindowSetAreas(Main, Menu, NULL, NULL, NULL, Form);
    XtRealizeWidget(TopLevel);
    XtAppMainLoop(AppCtx);
    return 0;   
} /* main */
